Subject: [tcpm] Fwd: New Version Notification for draft-mcquistin-augmented-tcp-example-00.txt

From: Stephen McQuistin <[email-masked]>
Date: Mon, 16 Nov 2020 20:54:40 +0000

Hi all,

I want to highlight this draft (draft-mcquistin-augmented-tcp-example) that might be of interest to the group.

The draft tries to mirror draft-ietf-tcpm-rfc793bis, but uses a machine-readable packet header diagram language (Augmented Packet Header Diagrams: draft-mcquistin-augmented-ascii-diagrams). The draft can be parsed by tooling that we’ve created (and described in the draft), and then used to generate a parser for the version of TCP it describes. This allows for an implementation to be generated directly from the document that describes the protocol, ensuring compatibility between the code and the specification.

As this is work-in-progress, there are limitations in the machine-readable format. This example draft has been written to try to explore those limitations (and the benefits of the approach).

It would be great to get feedback on this example specifically (e.g., how natural it is to read), and on the broader project. I’m happy to discuss on this list, and I’ll also be around on the Gather hallway. I’ll be outside Room 8 after both tomorrow’s TCPM session, and the TSVWG session on Wednesday.

Thanks!

Stephen 

> Begin forwarded message:
> 
> From: [email-masked]
> Subject: New Version Notification for draft-mcquistin-augmented-tcp-example-00.txt
> Date: 2 November 2020 at 22:25:44 GMT
> To: "Vivian Band" <[email-masked]>, "Stephen McQuistin" <[email-masked]>, "Colin Perkins" <[email-masked]>, "Dejice Jacob" <[email-masked]>
> 
> 
> A new version of I-D, draft-mcquistin-augmented-tcp-example-00.txt
> has been successfully submitted by Stephen McQuistin and posted to the
> IETF repository.
> 
> Name:		draft-mcquistin-augmented-tcp-example
> Revision:	00
> Title:		Describing TCP with Augmented Packet Header Diagrams
> Document date:	2020-11-02
> Group:		Individual Submission
> Pages:		10
> URL:            https://www.ietf.org/archive/id/draft-mcquistin-augmented-tcp-example-00.txt
> Status:         https://datatracker.ietf.org/doc/draft-mcquistin-augmented-tcp-example/
> Html:           https://www.ietf.org/archive/id/draft-mcquistin-augmented-tcp-example-00.html
> Htmlized:       https://tools.ietf.org/html/draft-mcquistin-augmented-tcp-example-00
> 
> 
> Abstract:
>   This document describes TCP, and a number of its extensions, using
>   Augmented Packet Header Diagrams.  This document is an example of the
>   Augmented Packet Header Diagram language: it is not intended as a
>   contribution to any ongoing or future work on maintaining or
>   extending TCP.
> 
> 
> 
> 
> Please note that it may take a couple of minutes from the time of submission
> until the htmlized version and diff are available at tools.ietf.org.
> 
> The IETF Secretariat
> 
>